Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 2231)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 2232)
@@ -2443,6 +2604,6 @@
 
        USE indices,                                                           &
-           ONLY:  nxl, nxr, nyn, nys, nzb, nzb_max, nzt, wall_flags_0,        &
-                  wall_flags_00
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzb_max, nzt, advc_flags_1,        &
+                  advc_flags_2
 
        USE kinds
@@ -2495,7 +2656,7 @@
 
           DO  k = nzb+1, nzb_max
-             ibit32 = IBITS(wall_flags_00(k,j-1,i),0,1)
-             ibit31 = IBITS(wall_flags_0(k,j-1,i),31,1)
-             ibit30 = IBITS(wall_flags_0(k,j-1,i),30,1)
+             ibit32 = IBITS(advc_flags_2(k,j-1,i),0,1)
+             ibit31 = IBITS(advc_flags_1(k,j-1,i),31,1)
+             ibit30 = IBITS(advc_flags_1(k,j-1,i),30,1)
 
              v_comp         = v(k+1,j,i) + v(k,j,i) - gv
@@ -2553,7 +2714,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit29 = IBITS(wall_flags_0(k,j,i-1),29,1)
-             ibit28 = IBITS(wall_flags_0(k,j,i-1),28,1)
-             ibit27 = IBITS(wall_flags_0(k,j,i-1),27,1)
+             ibit29 = IBITS(advc_flags_1(k,j,i-1),29,1)
+             ibit28 = IBITS(advc_flags_1(k,j,i-1),28,1)
+             ibit27 = IBITS(advc_flags_1(k,j,i-1),27,1)
 
              u_comp           = u(k+1,j,i) + u(k,j,i) - gu
@@ -2608,5 +2769,5 @@
 !--    The lower flux has to be calculated explicetely for the tendency at
 !--    the first w-level. For topography wall this is done implicitely by
-!--    wall_flags_0.
+!--    advc_flags_1.
        k         = nzb + 1
        w_comp    = w(k,j,i) + w(k-1,j,i)
@@ -2620,7 +2781,7 @@
        DO  k = nzb+1, nzb_max
 
-          ibit29 = IBITS(wall_flags_0(k,j,i),29,1)
-          ibit28 = IBITS(wall_flags_0(k,j,i),28,1)
-          ibit27 = IBITS(wall_flags_0(k,j,i),27,1)
+          ibit29 = IBITS(advc_flags_1(k,j,i),29,1)
+          ibit28 = IBITS(advc_flags_1(k,j,i),28,1)
+          ibit27 = IBITS(advc_flags_1(k,j,i),27,1)
 
           u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
@@ -2655,7 +2816,7 @@
                                         )
 
-          ibit32 = IBITS(wall_flags_00(k,j,i),0,1)
-          ibit31 = IBITS(wall_flags_0(k,j,i),31,1)
-          ibit30 = IBITS(wall_flags_0(k,j,i),30,1)
+          ibit32 = IBITS(advc_flags_2(k,j,i),0,1)
+          ibit31 = IBITS(advc_flags_1(k,j,i),31,1)
+          ibit30 = IBITS(advc_flags_1(k,j,i),30,1)
 
           v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
@@ -2692,7 +2853,7 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit35 = IBITS(wall_flags_00(k,j,i),3,1)
-          ibit34 = IBITS(wall_flags_00(k,j,i),2,1)
-          ibit33 = IBITS(wall_flags_00(k,j,i),1,1)
+          ibit35 = IBITS(advc_flags_2(k,j,i),3,1)
+          ibit34 = IBITS(advc_flags_2(k,j,i),2,1)
+          ibit33 = IBITS(advc_flags_2(k,j,i),1,1)
 
           k_ppp = k + 3 * ibit35
@@ -2737,21 +2898,21 @@
           div = ( ( ( u_comp + gu ) * ( ibit27 + ibit28 + ibit29 )            &
                   - ( u(k+1,j,i) + u(k,j,i)   )                               & 
-                                    * ( IBITS(wall_flags_0(k,j,i-1),27,1)     &
-                                      + IBITS(wall_flags_0(k,j,i-1),28,1)     &
-                                      + IBITS(wall_flags_0(k,j,i-1),29,1)     &
+                                    * ( IBITS(advc_flags_1(k,j,i-1),27,1)     &
+                                      + IBITS(advc_flags_1(k,j,i-1),28,1)     &
+                                      + IBITS(advc_flags_1(k,j,i-1),29,1)     &
                                       )                                       &
                   ) * rho_air_zw(k) * ddx                                     &
               +   ( ( v_comp + gv ) * ( ibit30 + ibit31 + ibit32 )            & 
                   - ( v(k+1,j,i) + v(k,j,i)   )                               &
-                                    * ( IBITS(wall_flags_0(k,j-1,i),30,1)     &
-                                      + IBITS(wall_flags_0(k,j-1,i),31,1)     &
-                                      + IBITS(wall_flags_00(k,j-1,i),0,1)     &
+                                    * ( IBITS(advc_flags_1(k,j-1,i),30,1)     &
+                                      + IBITS(advc_flags_1(k,j-1,i),31,1)     &
+                                      + IBITS(advc_flags_2(k,j-1,i),0,1)      &
                                       )                                       &
                   ) * rho_air_zw(k) * ddy                                     &
               +   ( w_comp * rho_air(k+1) * ( ibit33 + ibit34 + ibit35 )      &
                 - ( w(k,j,i)   + w(k-1,j,i)   ) * rho_air(k)                  &
-                                    * ( IBITS(wall_flags_00(k-1,j,i),1,1)     &
-                                      + IBITS(wall_flags_00(k-1,j,i),2,1)     &
-                                      + IBITS(wall_flags_00(k-1,j,i),3,1)     &
+                                    * ( IBITS(advc_flags_2(k-1,j,i),1,1)      &
+                                      + IBITS(advc_flags_2(k-1,j,i),2,1)      &
+                                      + IBITS(advc_flags_2(k-1,j,i),3,1)      &
                                       )                                       & 
                   ) * ddzu(k+1)   &
@@ -2814,7 +2975,7 @@
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit35 = IBITS(wall_flags_00(k,j,i),3,1)
-          ibit34 = IBITS(wall_flags_00(k,j,i),2,1)
-          ibit33 = IBITS(wall_flags_00(k,j,i),1,1)
+          ibit35 = IBITS(advc_flags_2(k,j,i),3,1)
+          ibit34 = IBITS(advc_flags_2(k,j,i),2,1)
+          ibit33 = IBITS(advc_flags_2(k,j,i),1,1)
 
           k_ppp = k + 3 * ibit35
@@ -2919,5 +3080,5 @@
        USE indices,                                                           &
            ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzb_max,   &
-                  nzt, wall_flags_0
+                  nzt, advc_flags_1
            
        USE kinds
@@ -2983,7 +3144,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit2 = IBITS(wall_flags_0(k,j,i-1),2,1)
-             ibit1 = IBITS(wall_flags_0(k,j,i-1),1,1)
-             ibit0 = IBITS(wall_flags_0(k,j,i-1),0,1)
+             ibit2 = IBITS(advc_flags_1(k,j,i-1),2,1)
+             ibit1 = IBITS(advc_flags_1(k,j,i-1),1,1)
+             ibit0 = IBITS(advc_flags_1(k,j,i-1),0,1)
 
              u_comp                 = u(k,j,i) - u_gtrans
@@ -3044,7 +3205,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit5 = IBITS(wall_flags_0(k,j-1,i),5,1)
-             ibit4 = IBITS(wall_flags_0(k,j-1,i),4,1)
-             ibit3 = IBITS(wall_flags_0(k,j-1,i),3,1)
+             ibit5 = IBITS(advc_flags_1(k,j-1,i),5,1)
+             ibit4 = IBITS(advc_flags_1(k,j-1,i),4,1)
+             ibit3 = IBITS(advc_flags_1(k,j-1,i),3,1)
 
              v_comp               = v(k,j,i) - v_gtrans
@@ -3107,7 +3268,7 @@
              DO  k = nzb+1, nzb_max
 
-                ibit2 = IBITS(wall_flags_0(k,j,i),2,1)
-                ibit1 = IBITS(wall_flags_0(k,j,i),1,1)
-                ibit0 = IBITS(wall_flags_0(k,j,i),0,1)
+                ibit2 = IBITS(advc_flags_1(k,j,i),2,1)
+                ibit1 = IBITS(advc_flags_1(k,j,i),1,1)
+                ibit0 = IBITS(advc_flags_1(k,j,i),0,1)
 
                 u_comp    = u(k,j,i+1) - u_gtrans
@@ -3142,7 +3303,7 @@
                                              )
 
-                ibit5 = IBITS(wall_flags_0(k,j,i),5,1)
-                ibit4 = IBITS(wall_flags_0(k,j,i),4,1)
-                ibit3 = IBITS(wall_flags_0(k,j,i),3,1)
+                ibit5 = IBITS(advc_flags_1(k,j,i),5,1)
+                ibit4 = IBITS(advc_flags_1(k,j,i),4,1)
+                ibit3 = IBITS(advc_flags_1(k,j,i),3,1)
 
                 v_comp    = v(k,j+1,i) - v_gtrans
@@ -3179,7 +3340,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit8 = IBITS(wall_flags_0(k,j,i),8,1)
-                ibit7 = IBITS(wall_flags_0(k,j,i),7,1)
-                ibit6 = IBITS(wall_flags_0(k,j,i),6,1)
+                ibit8 = IBITS(advc_flags_1(k,j,i),8,1)
+                ibit7 = IBITS(advc_flags_1(k,j,i),7,1)
+                ibit6 = IBITS(advc_flags_1(k,j,i),6,1)
 
                 k_ppp = k + 3 * ibit8
@@ -3221,13 +3382,13 @@
 !--             by a not sufficient reduction of divergences near topography.
                 div   =   ( u(k,j,i+1) * ( ibit0 + ibit1 + ibit2 )             &
-                          - u(k,j,i)   * ( IBITS(wall_flags_0(k,j,i-1),0,1)    &
-                                         + IBITS(wall_flags_0(k,j,i-1),1,1)    &
-                                         + IBITS(wall_flags_0(k,j,i-1),2,1)    &
+                          - u(k,j,i)   * ( IBITS(advc_flags_1(k,j,i-1),0,1)    &
+                                         + IBITS(advc_flags_1(k,j,i-1),1,1)    &
+                                         + IBITS(advc_flags_1(k,j,i-1),2,1)    &
                                          )                                     &
                           ) * rho_air(k) * ddx                                 &
                         + ( v(k,j+1,i) * ( ibit3 + ibit4 + ibit5 )             &
-                          - v(k,j,i)   * ( IBITS(wall_flags_0(k,j-1,i),3,1)    &
-                                         + IBITS(wall_flags_0(k,j-1,i),4,1)    &
-                                         + IBITS(wall_flags_0(k,j-1,i),5,1)    &
+                          - v(k,j,i)   * ( IBITS(advc_flags_1(k,j-1,i),3,1)    &
+                                         + IBITS(advc_flags_1(k,j-1,i),4,1)    &
+                                         + IBITS(advc_flags_1(k,j-1,i),5,1)    &
                                          )                                     &
                           ) * rho_air(k) * ddy                                 &
@@ -3235,7 +3396,7 @@
                                          ( ibit6 + ibit7 + ibit8 )             &
                           - w(k-1,j,i) * rho_air_zw(k-1) *                     &
-                                         ( IBITS(wall_flags_0(k-1,j,i),6,1)    &
-                                         + IBITS(wall_flags_0(k-1,j,i),7,1)    &
-                                         + IBITS(wall_flags_0(k-1,j,i),8,1)    &
+                                         ( IBITS(advc_flags_1(k-1,j,i),6,1)    &
+                                         + IBITS(advc_flags_1(k-1,j,i),7,1)    &
+                                         + IBITS(advc_flags_1(k-1,j,i),8,1)    &
                                          )                                     &      
                           ) * ddzw(k)
@@ -3285,7 +3446,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit8 = IBITS(wall_flags_0(k,j,i),8,1)
-                ibit7 = IBITS(wall_flags_0(k,j,i),7,1)
-                ibit6 = IBITS(wall_flags_0(k,j,i),6,1)
+                ibit8 = IBITS(advc_flags_1(k,j,i),8,1)
+                ibit7 = IBITS(advc_flags_1(k,j,i),7,1)
+                ibit6 = IBITS(advc_flags_1(k,j,i),6,1)
 
                 k_ppp = k + 3 * ibit8
@@ -3429,5 +3590,4 @@
 
 
-
 !------------------------------------------------------------------------------!
 ! Description:
@@ -3450,5 +3610,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxlu, nxr, nyn, nys, nzb, nzb_max, nzt, wall_flags_0
+           ONLY:  nxl, nxlu, nxr, nyn, nys, nzb, nzb_max, nzt, advc_flags_1
            
        USE kinds
@@ -3507,7 +3667,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit11 = IBITS(wall_flags_0(k,j,i-1),11,1)
-             ibit10 = IBITS(wall_flags_0(k,j,i-1),10,1)
-             ibit9  = IBITS(wall_flags_0(k,j,i-1),9,1)
+             ibit11 = IBITS(advc_flags_1(k,j,i-1),11,1)
+             ibit10 = IBITS(advc_flags_1(k,j,i-1),10,1)
+             ibit9  = IBITS(advc_flags_1(k,j,i-1),9,1)
 
              u_comp(k)                = u(k,j,i) + u(k,j,i-1) - gu
@@ -3565,7 +3725,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit14 = IBITS(wall_flags_0(k,j-1,i),14,1)
-             ibit13 = IBITS(wall_flags_0(k,j-1,i),13,1)
-             ibit12 = IBITS(wall_flags_0(k,j-1,i),12,1)
+             ibit14 = IBITS(advc_flags_1(k,j-1,i),14,1)
+             ibit13 = IBITS(advc_flags_1(k,j-1,i),13,1)
+             ibit12 = IBITS(advc_flags_1(k,j-1,i),12,1)
 
              v_comp                 = v(k,j,i) + v(k,j,i-1) - gv
@@ -3626,7 +3786,7 @@
              DO  k = nzb+1, nzb_max
 
-                ibit11 = IBITS(wall_flags_0(k,j,i),11,1)
-                ibit10 = IBITS(wall_flags_0(k,j,i),10,1)
-                ibit9  = IBITS(wall_flags_0(k,j,i),9,1)
+                ibit11 = IBITS(advc_flags_1(k,j,i),11,1)
+                ibit10 = IBITS(advc_flags_1(k,j,i),10,1)
+                ibit9  = IBITS(advc_flags_1(k,j,i),9,1)
 
                 u_comp(k) = u(k,j,i+1) + u(k,j,i)
@@ -3661,7 +3821,7 @@
                                                      )
 
-                ibit14 = IBITS(wall_flags_0(k,j,i),14,1)
-                ibit13 = IBITS(wall_flags_0(k,j,i),13,1)
-                ibit12 = IBITS(wall_flags_0(k,j,i),12,1)
+                ibit14 = IBITS(advc_flags_1(k,j,i),14,1)
+                ibit13 = IBITS(advc_flags_1(k,j,i),13,1)
+                ibit12 = IBITS(advc_flags_1(k,j,i),12,1)
 
                 v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
@@ -3698,7 +3858,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit17 = IBITS(wall_flags_0(k,j,i),17,1)
-                ibit16 = IBITS(wall_flags_0(k,j,i),16,1)
-                ibit15 = IBITS(wall_flags_0(k,j,i),15,1)
+                ibit17 = IBITS(advc_flags_1(k,j,i),17,1)
+                ibit16 = IBITS(advc_flags_1(k,j,i),16,1)
+                ibit15 = IBITS(advc_flags_1(k,j,i),15,1)
 
                 k_ppp = k + 3 * ibit17
@@ -3742,21 +3902,21 @@
                 div = ( ( u_comp(k) * ( ibit9 + ibit10 + ibit11 )             &
                 - ( u(k,j,i)   + u(k,j,i-1)   )                               &
-                                    * ( IBITS(wall_flags_0(k,j,i-1),9,1)      &
-                                      + IBITS(wall_flags_0(k,j,i-1),10,1)     &
-                                      + IBITS(wall_flags_0(k,j,i-1),11,1)     &
+                                    * ( IBITS(advc_flags_1(k,j,i-1),9,1)      &
+                                      + IBITS(advc_flags_1(k,j,i-1),10,1)     &
+                                      + IBITS(advc_flags_1(k,j,i-1),11,1)     &
                                       )                                       &
                   ) * rho_air(k) * ddx                                        &
                +  ( ( v_comp + gv ) * ( ibit12 + ibit13 + ibit14 )            &
                   - ( v(k,j,i)   + v(k,j,i-1 )  )                             &
-                                    * ( IBITS(wall_flags_0(k,j-1,i),12,1)     &
-                                      + IBITS(wall_flags_0(k,j-1,i),13,1)     &
-                                      + IBITS(wall_flags_0(k,j-1,i),14,1)     &
+                                    * ( IBITS(advc_flags_1(k,j-1,i),12,1)     &
+                                      + IBITS(advc_flags_1(k,j-1,i),13,1)     &
+                                      + IBITS(advc_flags_1(k,j-1,i),14,1)     &
                                       )                                       &
                   ) * rho_air(k) * ddy                                        &
                +  ( w_comp * rho_air_zw(k) * ( ibit15 + ibit16 + ibit17 )     &
                 - ( w(k-1,j,i) + w(k-1,j,i-1) ) * rho_air_zw(k-1)             &
-                                    * ( IBITS(wall_flags_0(k-1,j,i),15,1)     &
-                                      + IBITS(wall_flags_0(k-1,j,i),16,1)     &
-                                      + IBITS(wall_flags_0(k-1,j,i),17,1)     &
+                                    * ( IBITS(advc_flags_1(k-1,j,i),15,1)     &
+                                      + IBITS(advc_flags_1(k-1,j,i),16,1)     &
+                                      + IBITS(advc_flags_1(k-1,j,i),17,1)     &
                                       )                                       &  
                   ) * ddzw(k)   &
@@ -3829,7 +3989,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit17 = IBITS(wall_flags_0(k,j,i),17,1)
-                ibit16 = IBITS(wall_flags_0(k,j,i),16,1)
-                ibit15 = IBITS(wall_flags_0(k,j,i),15,1)
+                ibit17 = IBITS(advc_flags_1(k,j,i),17,1)
+                ibit16 = IBITS(advc_flags_1(k,j,i),16,1)
+                ibit15 = IBITS(advc_flags_1(k,j,i),15,1)
 
                 k_ppp = k + 3 * ibit17
@@ -3925,5 +4085,5 @@
     END SUBROUTINE advec_u_ws
     
-    
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -3946,5 +4106,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nysv, nzb, nzb_max, nzt, wall_flags_0
+           ONLY:  nxl, nxr, nyn, nys, nysv, nzb, nzb_max, nzt, advc_flags_1
 
        USE kinds
@@ -4003,7 +4163,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit20 = IBITS(wall_flags_0(k,j,i-1),20,1)
-             ibit19 = IBITS(wall_flags_0(k,j,i-1),19,1)
-             ibit18 = IBITS(wall_flags_0(k,j,i-1),18,1)
+             ibit20 = IBITS(advc_flags_1(k,j,i-1),20,1)
+             ibit19 = IBITS(advc_flags_1(k,j,i-1),19,1)
+             ibit18 = IBITS(advc_flags_1(k,j,i-1),18,1)
 
              u_comp                   = u(k,j-1,i) + u(k,j,i) - gu
@@ -4061,7 +4221,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit23 = IBITS(wall_flags_0(k,j-1,i),23,1)
-             ibit22 = IBITS(wall_flags_0(k,j-1,i),22,1)
-             ibit21 = IBITS(wall_flags_0(k,j-1,i),21,1)
+             ibit23 = IBITS(advc_flags_1(k,j-1,i),23,1)
+             ibit22 = IBITS(advc_flags_1(k,j-1,i),22,1)
+             ibit21 = IBITS(advc_flags_1(k,j-1,i),21,1)
 
              v_comp(k)              = v(k,j,i) + v(k,j-1,i) - gv
@@ -4121,7 +4281,7 @@
              DO  k = nzb+1, nzb_max
 
-                ibit20 = IBITS(wall_flags_0(k,j,i),20,1)
-                ibit19 = IBITS(wall_flags_0(k,j,i),19,1)
-                ibit18 = IBITS(wall_flags_0(k,j,i),18,1)
+                ibit20 = IBITS(advc_flags_1(k,j,i),20,1)
+                ibit19 = IBITS(advc_flags_1(k,j,i),19,1)
+                ibit18 = IBITS(advc_flags_1(k,j,i),18,1)
 
                 u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
@@ -4156,7 +4316,7 @@
                                               )
 
-                ibit23 = IBITS(wall_flags_0(k,j,i),23,1)
-                ibit22 = IBITS(wall_flags_0(k,j,i),22,1)
-                ibit21 = IBITS(wall_flags_0(k,j,i),21,1)
+                ibit23 = IBITS(advc_flags_1(k,j,i),23,1)
+                ibit22 = IBITS(advc_flags_1(k,j,i),22,1)
+                ibit21 = IBITS(advc_flags_1(k,j,i),21,1)
 
                 v_comp(k) = v(k,j+1,i) + v(k,j,i)
@@ -4193,7 +4353,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit26 = IBITS(wall_flags_0(k,j,i),26,1)
-                ibit25 = IBITS(wall_flags_0(k,j,i),25,1)
-                ibit24 = IBITS(wall_flags_0(k,j,i),24,1)
+                ibit26 = IBITS(advc_flags_1(k,j,i),26,1)
+                ibit25 = IBITS(advc_flags_1(k,j,i),25,1)
+                ibit24 = IBITS(advc_flags_1(k,j,i),24,1)
 
                 k_ppp = k + 3 * ibit26
@@ -4238,7 +4398,7 @@
                                        * ( ibit18 + ibit19 + ibit20 )         &
                 - ( u(k,j-1,i)   + u(k,j,i) )                                 &
-                                       * ( IBITS(wall_flags_0(k,j,i-1),18,1)  &
-                                         + IBITS(wall_flags_0(k,j,i-1),19,1)  &
-                                         + IBITS(wall_flags_0(k,j,i-1),20,1)  &
+                                       * ( IBITS(advc_flags_1(k,j,i-1),18,1)  &
+                                         + IBITS(advc_flags_1(k,j,i-1),19,1)  &
+                                         + IBITS(advc_flags_1(k,j,i-1),20,1)  &
                                          )                                    &
                   ) * rho_air(k) * ddx                                        &
@@ -4246,7 +4406,7 @@
                                        * ( ibit21 + ibit22 + ibit23 )         &
                 - ( v(k,j,i)     + v(k,j-1,i) )                               &
-                                       * ( IBITS(wall_flags_0(k,j-1,i),21,1)  &
-                                         + IBITS(wall_flags_0(k,j-1,i),22,1)  &
-                                         + IBITS(wall_flags_0(k,j-1,i),23,1)  &
+                                       * ( IBITS(advc_flags_1(k,j-1,i),21,1)  &
+                                         + IBITS(advc_flags_1(k,j-1,i),22,1)  &
+                                         + IBITS(advc_flags_1(k,j-1,i),23,1)  &
                                          )                                    &
                   ) * rho_air(k) * ddy                                        &
@@ -4254,7 +4414,7 @@
                                        * ( ibit24 + ibit25 + ibit26 )         &
                 - ( w(k-1,j-1,i) + w(k-1,j,i) ) * rho_air_zw(k-1)             &
-                                       * ( IBITS(wall_flags_0(k-1,j,i),24,1)  &
-                                         + IBITS(wall_flags_0(k-1,j,i),25,1)  &
-                                         + IBITS(wall_flags_0(k-1,j,i),26,1)  &
+                                       * ( IBITS(advc_flags_1(k-1,j,i),24,1)  &
+                                         + IBITS(advc_flags_1(k-1,j,i),25,1)  &
+                                         + IBITS(advc_flags_1(k-1,j,i),26,1)  &
                                          )                                    &
                    ) * ddzw(k)   &
@@ -4332,7 +4492,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit26 = IBITS(wall_flags_0(k,j,i),26,1)
-                ibit25 = IBITS(wall_flags_0(k,j,i),25,1)
-                ibit24 = IBITS(wall_flags_0(k,j,i),24,1)
+                ibit26 = IBITS(advc_flags_1(k,j,i),26,1)
+                ibit25 = IBITS(advc_flags_1(k,j,i),25,1)
+                ibit24 = IBITS(advc_flags_1(k,j,i),24,1)
 
                 k_ppp = k + 3 * ibit26
@@ -4433,6 +4593,4 @@
     
     
-    
-    
 !------------------------------------------------------------------------------!
 ! Description:
@@ -4455,6 +4613,6 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nzb, nzb_max, nzt, wall_flags_0,         &
-                  wall_flags_00
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzb_max, nzt, advc_flags_1,         &
+                  advc_flags_2
 
        USE kinds
@@ -4512,7 +4670,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit29 = IBITS(wall_flags_0(k,j,i-1),29,1)
-             ibit28 = IBITS(wall_flags_0(k,j,i-1),28,1)
-             ibit27 = IBITS(wall_flags_0(k,j,i-1),27,1)
+             ibit29 = IBITS(advc_flags_1(k,j,i-1),29,1)
+             ibit28 = IBITS(advc_flags_1(k,j,i-1),28,1)
+             ibit27 = IBITS(advc_flags_1(k,j,i-1),27,1)
 
              u_comp                   = u(k+1,j,i) + u(k,j,i) - gu
@@ -4570,7 +4728,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit32 = IBITS(wall_flags_00(k,j-1,i),0,1)
-             ibit31 = IBITS(wall_flags_0(k,j-1,i),31,1)
-             ibit30 = IBITS(wall_flags_0(k,j-1,i),30,1)
+             ibit32 = IBITS(advc_flags_2(k,j-1,i),0,1)
+             ibit31 = IBITS(advc_flags_1(k,j-1,i),31,1)
+             ibit30 = IBITS(advc_flags_1(k,j-1,i),30,1)
 
              v_comp                 = v(k+1,j,i) + v(k,j,i) - gv
@@ -4626,5 +4784,5 @@
 !--          The lower flux has to be calculated explicetely for the tendency
 !--          at the first w-level. For topography wall this is done implicitely
-!--          by wall_flags_0.
+!--          by advc_flags_1.
              k         = nzb + 1
              w_comp    = w(k,j,i) + w(k-1,j,i)
@@ -4636,7 +4794,7 @@
              DO  k = nzb+1, nzb_max
 
-                ibit29 = IBITS(wall_flags_0(k,j,i),29,1)
-                ibit28 = IBITS(wall_flags_0(k,j,i),28,1)
-                ibit27 = IBITS(wall_flags_0(k,j,i),27,1)
+                ibit29 = IBITS(advc_flags_1(k,j,i),29,1)
+                ibit28 = IBITS(advc_flags_1(k,j,i),28,1)
+                ibit27 = IBITS(advc_flags_1(k,j,i),27,1)
 
                 u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
@@ -4671,7 +4829,7 @@
                                               )
 
-                ibit32 = IBITS(wall_flags_00(k,j,i),0,1)
-                ibit31 = IBITS(wall_flags_0(k,j,i),31,1)
-                ibit30 = IBITS(wall_flags_0(k,j,i),30,1)
+                ibit32 = IBITS(advc_flags_2(k,j,i),0,1)
+                ibit31 = IBITS(advc_flags_1(k,j,i),31,1)
+                ibit30 = IBITS(advc_flags_1(k,j,i),30,1)
 
                 v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
@@ -4708,7 +4866,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit35 = IBITS(wall_flags_00(k,j,i),3,1)
-                ibit34 = IBITS(wall_flags_00(k,j,i),2,1)
-                ibit33 = IBITS(wall_flags_00(k,j,i),1,1)
+                ibit35 = IBITS(advc_flags_2(k,j,i),3,1)
+                ibit34 = IBITS(advc_flags_2(k,j,i),2,1)
+                ibit33 = IBITS(advc_flags_2(k,j,i),1,1)
 
                 k_ppp = k + 3 * ibit35
@@ -4752,21 +4910,21 @@
                 div = ( ( ( u_comp + gu ) * ( ibit27 + ibit28 + ibit29 )      &
                   - ( u(k+1,j,i) + u(k,j,i)   )                               & 
-                                    * ( IBITS(wall_flags_0(k,j,i-1),27,1)     &
-                                      + IBITS(wall_flags_0(k,j,i-1),28,1)     &
-                                      + IBITS(wall_flags_0(k,j,i-1),29,1)     &
+                                    * ( IBITS(advc_flags_1(k,j,i-1),27,1)     &
+                                      + IBITS(advc_flags_1(k,j,i-1),28,1)     &
+                                      + IBITS(advc_flags_1(k,j,i-1),29,1)     &
                                       )                                       &
                   ) * rho_air_zw(k) * ddx                                     &
               +   ( ( v_comp + gv ) * ( ibit30 + ibit31 + ibit32 )            &
                   - ( v(k+1,j,i) + v(k,j,i)   )                               &
-                                    * ( IBITS(wall_flags_0(k,j-1,i),30,1)     &
-                                      + IBITS(wall_flags_0(k,j-1,i),31,1)     &
-                                      + IBITS(wall_flags_00(k,j-1,i),0,1)     &
+                                    * ( IBITS(advc_flags_1(k,j-1,i),30,1)     &
+                                      + IBITS(advc_flags_1(k,j-1,i),31,1)     &
+                                      + IBITS(advc_flags_2(k,j-1,i),0,1)      &
                                       )                                       &
                   ) * rho_air_zw(k) * ddy                                     &
               +   ( w_comp * rho_air(k+1) * ( ibit33 + ibit34 + ibit35 )      &
                 - ( w(k,j,i)   + w(k-1,j,i)   ) * rho_air(k)                  &
-                                    * ( IBITS(wall_flags_00(k-1,j,i),1,1)     &
-                                      + IBITS(wall_flags_00(k-1,j,i),2,1)     &
-                                      + IBITS(wall_flags_00(k-1,j,i),3,1)     &
+                                    * ( IBITS(advc_flags_2(k-1,j,i),1,1)      &
+                                      + IBITS(advc_flags_2(k-1,j,i),2,1)      &
+                                      + IBITS(advc_flags_2(k-1,j,i),3,1)      &
                                       )                                       & 
                   ) * ddzu(k+1)   &
@@ -4831,7 +4989,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit35 = IBITS(wall_flags_00(k,j,i),3,1)
-                ibit34 = IBITS(wall_flags_00(k,j,i),2,1)
-                ibit33 = IBITS(wall_flags_00(k,j,i),1,1)
+                ibit35 = IBITS(advc_flags_2(k,j,i),3,1)
+                ibit34 = IBITS(advc_flags_2(k,j,i),2,1)
+                ibit33 = IBITS(advc_flags_2(k,j,i),1,1)
 
                 k_ppp = k + 3 * ibit35
@@ -4916,4 +5074,3 @@
     END SUBROUTINE advec_w_ws
 
-
  END MODULE advec_ws
Index: /palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/average_3d_data.f90	(revision 2231)
+++ /palm/trunk/SOURCE/average_3d_data.f90	(revision 2232)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new surface concept - additional ghost point exchange 
+! of surface variable required
 ! 
 ! Former revisions:
@@ -104,5 +105,6 @@
 
     USE control_parameters,                                                    &
-        ONLY:  average_count_3d, doav, doav_n, urban_surface, varnamelength
+        ONLY:  average_count_3d, doav, doav_n, land_surface, urban_surface,    &
+               varnamelength
 
     USE cpulog,                                                                &
@@ -110,10 +112,10 @@
 
     USE indices,                                                               &
-        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
+        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
 
     USE kinds
 
     USE land_surface_model_mod,                                                &
-        ONLY:  land_surface, lsm_3d_data_averaging
+        ONLY:  lsm_3d_data_averaging
 
     USE radiation_model_mod,                                                   &
@@ -171,4 +173,5 @@
                 ENDDO
              ENDDO
+             CALL exchange_horiz_2d( qsws_av, nbgp )
 
           CASE ( 'lpt' )
@@ -203,4 +206,5 @@
                 ENDDO
              ENDDO
+             CALL exchange_horiz_2d( ol_av, nbgp )
 
           CASE ( 'p' )
@@ -354,4 +358,5 @@
                 ENDDO
              ENDDO
+             CALL exchange_horiz_2d( shf_av, nbgp )
 
           CASE ( 'ssws*' )
@@ -361,4 +366,5 @@
                 ENDDO
              ENDDO
+             CALL exchange_horiz_2d( ssws_av, nbgp )
 
           CASE ( 't*' )
@@ -368,4 +374,5 @@
                 ENDDO
              ENDDO
+             CALL exchange_horiz_2d( ts_av, nbgp )
 
           CASE ( 'u' )
@@ -384,4 +391,5 @@
                 ENDDO
              ENDDO
+             CALL exchange_horiz_2d( us_av, nbgp )
 
           CASE ( 'v' )
@@ -418,4 +426,5 @@
                 ENDDO
              ENDDO
+             CALL exchange_horiz_2d( z0_av, nbgp )
 
           CASE ( 'z0h*' )
@@ -425,4 +434,5 @@
                 ENDDO
              ENDDO
+             CALL exchange_horiz_2d( z0h_av, nbgp )
 !             
 !--       Block of urban surface model outputs   
